tween = require 'libraries/tween'
timer = require 'libraries/hump/timer'

function love.load()
	img_enemy_slime = {}
	img_enemy_slime[1] = love.graphics.newImage('images/enemies/slime/1.png')
	img_enemy_slime[2] = love.graphics.newImage('images/enemies/slime/2.png')
	img_enemy_slime[3] = love.graphics.newImage('images/enemies/slime/3.png')
	
	img_player = {normal = love.graphics.newImage('images/player/normal.png'), jump = love.graphics.newImage('images/player/jump.png')}
	
	font_damage = love.graphics.newFont(40)
	
	player = {x=150, y=268, image = img_player.normal, onground=1, health=100}
	enemy = {x=700, y=300, image=img_enemy_slime[1]}
	
	enemy_attack()
	timer.addPeriodic(5, function()
		enemy_attack()
	end)
end

function enemy_attack()
	tween(0.75, enemy, {x=300})
	timer.add(1, function()
		tween(0.5, enemy, {x=200,y=150}, 'outQuad')
		enemy.image = img_enemy_slime[2]
	end)
	timer.add(1.5, function()
		tween(0.2, enemy, {x=150,y=300})
		enemy.image = img_enemy_slime[3]
	end)
	timer.add(1.7, function()
		if player.onground==1 then
			player_damage(20)
		end
	end)
	timer.add(1.8, function()
		tween(0.5, enemy, {x=700})
		enemy.image = img_enemy_slime[1]
	end)
end

function love.keypressed(key)
	if key == ' ' and player.onground == 1 then
		player.onground = 0
		tween(0.5, player, {y=150}, 'outQuad')
		player.image = img_player.jump
		timer.add(0.5, function()
			tween(0.5, player, {y=268}, 'inQuad')
		end)
		timer.add(1, function()
			player.onground=1
			player.image = img_player.normal
		end)
	end
end

function love.update(dt)
	tween.update(dt)
	timer.update(dt)
end

function player_damage(health)
	print('mwahahah')
	player.health = player.health-health
	damage_message = {x = player.x, y = player.y, text = tostring(health), scale = 3, alpha = 255}
	tween(0.05, damage_message, {scale = 1})
	timer.add(0.5, function()
		tween(0.5, damage_message, {scale = 0.3, alpha = 0})
	end)
end

function love.draw()
	love.graphics.setColor(255, 255, 255, 255)
	love.graphics.draw(enemy.image, enemy.x, enemy.y, 0, 1, 1, enemy.image:getWidth()/2, enemy.image:getHeight()/2)
	love.graphics.draw(player.image, player.x, player.y, 0, 1, 1, player.image:getWidth()/2, player.image:getHeight()/2)
	
	if damage_message then
		love.graphics.setFont(font_damage)
		love.graphics.setColor(255, 0, 0, damage_message.alpha)
		love.graphics.print(damage_message.text, damage_message.x, damage_message.y, 0, damage_message.scale, damage_message.scale)
	end
end